# Postfix requires one exlusive uid/gid and a 2nd exclusive gid.
%define postfix_uid    89
%define postfix_gid    89
%define maildrop_group postdrop
%define maildrop_gid   90

Summary: Postfix Mail Transport Agent
Name: postfix
Version: 2.0.16
Release: 1
Group: System Environment/Daemons
License: IBM Public License
URL: http://www.postfix.org/
Packager: Hao Li <hli@haoli.org>
Source0: ftp://ftp.porcupine.org/mirrors/postfix-release/official/%{name}-%{version}.tar.gz
Source1: postfix.init
Source2: postfix.aliases
Source3: postfix.Makefile
BuildRoot: %{_tmppath}/%{name}-root
Obsoletes: sendmail exim qmail
Provides: MTA smtpd smtpdaemon
BuildRequires: gawk, perl, sed, ed, db4-devel

Requires: pcre
BuildRequires: pcre, pcre-devel

%description
Postfix is a Mail Transport Agent (MTA).


%prep
%setup -q


%build

make -f Makefile.init makefiles
make DEBUG="" OPT="$RPM_OPT_FLAGS"


%install
rm -rf $RPM_BUILD_ROOT

# These two symbolic links create problems so we replace them with files.
for i in INSTALL RELEASE_NOTES; do
	rm -f README_FILES/$i
	cp -p $i README_FILES
done

sh postfix-install -non-interactive \
       install_root=$RPM_BUILD_ROOT \
       config_directory=%{_sysconfdir}/postfix \
       daemon_directory=%{_libexecdir}/postfix \
       command_directory=%{_sbindir} \
       queue_directory=%{_var}/spool/postfix \
       sendmail_path=%{_sbindir}/sendmail \
       newaliases_path=%{_bindir}/newaliases \
       mailq_path=%{_bindir}/mailq \
       mail_owner=postfix \
       setgid_group=%{maildrop_group} \
       manpage_directory=%{_mandir} \
       sample_directory=%{_docdir}/%{name}-%{version}/samples \
       readme_directory=%{_docdir}/%{name}-%{version}/README_FILES

rm -rf samples
mv $RPM_BUILD_ROOT/%{_docdir}/%{name}-%{version}/samples .

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -p -m755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/postfix
install -p -m644 %{SOURCE2} $RPM_BUILD_ROOT/%{_sysconfdir}/postfix/aliases
install -p -m644 %{SOURCE3} $RPM_BUILD_ROOT/%{_sysconfdir}/postfix/Makefile
touch $RPM_BUILD_ROOT/%{_sysconfdir}/postfix/{aliases,access,canonical,relocated,transport,virtual}.db

# Change alias_maps and alias_database default directory
./bin/postconf -c $RPM_BUILD_ROOT%{_sysconfdir}/postfix -e \
	"alias_maps = hash:%{_sysconfdir}/postfix/aliases" \
	"alias_database = hash:%{_sysconfdir}/postfix/aliases"

mkdir -p $RPM_BUILD_ROOT/%{_var}/spool/postfix/{active,bounce,corrupt,defer,deferred,flush,incoming,private,saved,maildrop,public,pid}

# RPM compresses man pages automatically.
perl -pi -e 's|(/man[158]/.*\.[158])|$1.gz|' $RPM_BUILD_ROOT/%{_sysconfdir}/postfix/postfix-files


%pre
groupadd -g %{maildrop_gid} -r %{maildrop_group} 2>/dev/null || :
groupadd -g %{postfix_gid} -r postfix 2>/dev/null || :
groupadd -g 12 -r mail 2>/dev/null || :
useradd -d %{_var}/spool/postfix -s /bin/true -g postfix -G mail -M -r -u %{postfix_uid} postfix 2>/dev/null || :


%post
/sbin/chkconfig --add postfix
%{_sysconfdir}/postfix/post-install upgrade-package


%postun
if [ $1 = 0 ]; then
    userdel postfix 2>/dev/null || :
    groupdel %{postfix_gid} 2>/dev/null || :
    groupdel %{maildrop_gid} 2>/dev/null || :
fi


%files
%defattr(-,root,root)
%doc samples README_FILES

%config /etc/rc.d/init.d/postfix

%dir %{_sysconfdir}/postfix

%{_sysconfdir}/postfix/LICENSE
%{_sysconfdir}/postfix/main.cf.default
%{_sysconfdir}/postfix/post-install
%{_sysconfdir}/postfix/postfix-files
%{_sysconfdir}/postfix/postfix-script

%config %{_sysconfdir}/postfix/Makefile
%config %{_sysconfdir}/postfix/access
%config %{_sysconfdir}/postfix/aliases
%config %{_sysconfdir}/postfix/canonical
%config %{_sysconfdir}/postfix/main.cf
%config %{_sysconfdir}/postfix/master.cf
%config %{_sysconfdir}/postfix/pcre_table
%config %{_sysconfdir}/postfix/regexp_table
%config %{_sysconfdir}/postfix/relocated
%config %{_sysconfdir}/postfix/transport
%config %{_sysconfdir}/postfix/virtual

%verify(not md5 size mtime) %{_sysconfdir}/postfix/*.db

%{_bindir}/*
%{_libexecdir}/*

/usr/sbin/postalias
/usr/sbin/postcat
/usr/sbin/postconf
/usr/sbin/postfix
/usr/sbin/postkick
/usr/sbin/postlock
/usr/sbin/postlog
/usr/sbin/postmap
/usr/sbin/postsuper
/usr/sbin/sendmail
%attr(2755,root,%{maildrop_group}) %{_sbindir}/postdrop
%attr(2755,root,%{maildrop_group}) %{_sbindir}/postqueue

%{_mandir}/man*/*

# For correct directory permissions check postfix-files
%dir %{_var}/spool/postfix
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/active
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/bounce
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/corrupt
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/defer
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/deferred
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/flush
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/incoming
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/private
%dir %attr(0700,postfix,root)              %{_var}/spool/postfix/saved
%dir %attr(0730,postfix,%{maildrop_group}) %{_var}/spool/postfix/maildrop
%dir %attr(0710,postfix,%{maildrop_group}) %{_var}/spool/postfix/public
%dir %attr(0755,root,root)                 %{_var}/spool/postfix/pid


%clean
rm -rf $RPM_BUILD_ROOT

